#include <stdio.h>
#include <signal.h>
#include <pwd.h>
#include <unistd.h>
#include "yabbslib.h"

/*
 * thanks to jban@data.fls.dk for patches to make this work properly
 * and for variable shutdown times.
 */

extern int bbs_s;

void cli_page(char *name) {}
void cli_msgline(char *line, int type) {}
void cli_msghdrline(int x, char *to, char *from, char *del, char *subject) {}
void cli_talkline(char *channel, char *name, char *msg, int type) {}
void cli_textline(char *line) {}
void cli_planline(char *line) {}
void cli_gfileline(char *line) {}
void cli_gfileindexline(char *name, char *path, char *type) {}
void cli_msgbasename(int baseid, char *basename) {}
void cli_useroptions(char *name, int slen, unsigned long opt, char *subs) {}
void cli_founduser(char *name) {}

void cli_fatalerror(char *msg) {
    printf("FATAL: %s\n", msg);
    exit(1);
}

void cli_error(char *msg) {
    printf("warning: %s\n", msg);
}

void cli_wholine(char *name, char *onfrom, char *onsince, int idle) { }

void cli_channelline(char *channel, char *users) { }

void sigint() {
    printf("yshutdown: shutdown canceled\n");
    bbs_shutdown(SD_ENABLE, "shutdown canceled");
    exit(1);
}

void main(int argc, char **argv) {
    char userid[10], passwd[10], server[64];
    int ul, sleeptime;
    signal(SIGINT, sigint);

    sleeptime = (argc < 2) ? 60 : atoi(argv[1]);
    if (sleeptime < 0) sleeptime = -sleeptime;

    if (argc == 3) strncpy(server, argv[2], 63); else strcpy(server, SERVER);
    server[64] = 0;

    printf("yabbs login: "); fgets(userid, 9, stdin);
    userid[ul = strlen(userid)] = 0;
    if (ul) userid[--ul] = 0;
    strcpy(passwd, getpass("password: "));
    bbs_connect(server);
    bbs_login(userid, passwd);

    while (sleeptime > 4) {
        char warnmsg[80];

        sprintf(warnmsg, "system going down in %d seconds", sleeptime);
        printf("yshutdown: sending %d seconds warning\n", sleeptime);
        bbs_shutdown(SD_DISABLE, warnmsg);
        sleep(sleeptime /= 2);
    }
    sleep(sleeptime);
    printf("yshutdown: shutting down now\n");
    bbs_shutdown(SD_NOW, "system going down NOW");
    bbs_logout();
}
