/*
 * this file is a part of yabbs - yet another bulletin board system.
 * Copyright (C) 1993 Alex Wetmore.  
 * email: aw2t@andrew.cmu.edu
 * address: 6 rech ave
 *          oreland pa 19075
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * bbsdefs.h - part of the yabbs bulletin board package by alex wetmore
 *             see bbs.c for information on the system and copying.
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <strings.h>
#include <signal.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/time.h>
#ifdef AIX
#include <sys/select.h>
#endif
#if TERMIO
#include <termio.h>                         /* termio terminal control  */
#else
#include <sgtty.h>                          /* sgtty terminal control   */
#endif
#include <sys/ioctl.h>
#include <errno.h>
#include "termcap.h"
#include "yabbs.h"
#include "bbs_struct.h"
#include "menus.h"
#include "yabbslib/yabbslib.h"
#include "patchlevel.h"

#define YABBS
#ifndef TRUE
#define TRUE 1                              /* you might have these     */
#define FALSE 0
#endif
#define curtime time((time_t *) 0)
#define hion() t_puts(t_hion)
#define hioff() t_puts(t_hioff)
#define up() t_puts(t_upcur)

#ifndef EXTERN
#define EXTERN extern
#endif 

EXTERN  urec    userinfo;                   /* current user information */
EXTERN  int     bbs_s;                      /* socket for server        */
EXTERN  int     msgnum,                     /* number of messages       */
                usernum,                    /* number of users          */
                pid;                        /* our process id           */
EXTERN  brec    base[MBASES];               /* message base information */
EXTERN  int     b, m;                       /* current message base,
                                               current message          */
EXTERN  int     redraw,                     /* if true then redraw the
                                               input line               */
                line;                       /* current line on screen   */
EXTERN  char    replytitle[33];             /* title of last msg read   */
EXTERN  char    replyto[9];                 /* from field from last msg */
EXTERN  char    rlstart[80];                /* start of a new readline  */
EXTERN  char    rlwrap;                     /* TRUE if readline wrapped */
EXTERN  char    lstype, lstext[33];         /* last search type, last
                                                       text searched for        */
EXTERN  int     sputs_process;              /* sputs hilights with []   */
#if     TERMIO
EXTERN  struct  termio term, save;          /* terminal modes (termio)  */
#else
EXTERN  struct  sgttyb term, save;          /* terminal modes (sgtty)   */
#endif
EXTERN  char    termcap[1024],              /* termcap info             */
                t_clrscr[33],               /* code to clear screen     */
                t_hion[33],                 /* code to start highlight  */
                t_hioff[33],                /* code to end highlight    */
                t_cleol[81],                /* code to clear line       */
                t_upcur[33],                /* code to go up a line     */
                termname[33];               /* name of terminal         */
EXTERN  mrec    gmsg;                       /* global message structure */
EXTERN  grec    gfil[1000];                 /* global gfile structure   */
EXTERN  int     gnum;                       /* size of gfil             */
EXTERN  int     errorcode;                  /* global error code (like  */
                                            /*  error)                  */
EXTERN  int     yeck, elite;                /* cool modes for yalk      */
EXTERN  int     hnum;                       /* header num, for msghdrs  */

#include "bbsfuncs.h"                       /* function prototypes      */
