/*
 * this file is a part of yabbs - yet another bulletin board system.
 * Copyright (C) 1993 Alex Wetmore.  
 * email: aw2t@andrew.cmu.edu
 * address: 6 rech ave
 *          oreland pa 19075
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* ---- miscutil.c ---- */
char *itoa(int i);
int fexist(char *fname);
int putch(int c);
void t_puts(char *tstr);
void clrscr(void  );
void writelog(char *st);
void who(void  );
void sigquit(int i);
void sigstop(int i);
void sigcont(int i);
void killconnection(int message);
char readc(void  );
void writec(char c);
char waitfor(char *okaych);
char opton(int option);
void sputs(char *st);
void sputs_wr(char *st);
void sputs_mime(char *st);
int readl(char *ptr, register int maxlen, register int echo, char *fill);
int readlww(char *ptr, register int maxlen, int wrap_bs);
void sgets(char *st, int max);
void sgetpw(char *st);
void dump(char *filename);
void dumpsvr(char *filename);
void more(char *filename, int scrlen);
unsigned long int power(int base, int n);
int ynprompt(char *st, int def);
void strmid(char *dup, char *src, int beg, int n);
void substoint(unsigned long int *subsi, char *subs);
void inttosubs(char *subs, unsigned long int *subsi);
int accesscheck(int basenum);
int subcheck(int basenum);
void readbases(void  );
void drawuser(void  );
void changepw(void  );
void changesubs(void  );
int finduser(char *name);
void listusers(void  );
void updatelast(int usr, char *buf);
void changeplan(char *name);
void readplan(char *defname);
void waitkey(void  );
void saveopts(void  );
/* ---- msgbase.c ---- */
void addmsg(mrec msg);
int readmsg(int mnum);
int getmsgnum(void  );
void setlastmsg(int b, int m);
int getlastmsg(int b);
void changebase(int b);
void readnext(void  );
void readprev(void  );
void entermsg(char *outfile);
void selectbase(void  );
void jump2msg(void  );
mrec getmsg(int mnum);
mrec getmsghdr(int mnum);
void deletemsg(int mnum, int sysoponly);
void findmsg(void  );
void listmsgs(void  );
int domessages(void  );
/* ---- yalk.c ---- */
void dopage(char *tstr);
void doaction(char *tmsg);
void dowrite(char *tmsg);
void domsg(char *tmsg);
void dotalk(void  );
void getchannels(void);
/* ---- gfiles.c ---- */
void getgfileindex(char *path);
void getgfile(char *path);
int dogfil(char *p);
/* ---- strlwr.c ---- */
char *strlwr(char *st);
/* ---- tochars.c ---- */
char lower(char i);
char upper(char i);
/* ---- bbs.c ---- */
int doconfig(void  );
int newuser(void  );
int login(void  );
void getterm(void  );
void su(void  );
void dobbs(void  );
void yabbsmain(int argc, char **argv);
void yahoomain(int argc, char **argv);
/* ---- network.c ---- */
void csendp(char *msg);
char *creadp(void);
int c_yabbshi(char **argv);
int c_bad(char **argv);
int c_talk(char **argv);
int c_page(char **argv);
int c_who(char **argv);
int c_msg(char **argv);
int c_msghdr(char **argv);
int c_msgnum(char **argv);
int c_delmsgret(char **argv);
int c_basetitle(char **argv);
int c_useropts(char **argv);
int c_login(char **argv);
int c_lastmsg(char **argv);
int c_newuser(char **argv);
int c_founduser(char **argv);
int c_userexist(char **argv);
int c_txtfile(char **argv);
int c_planfile(char **argv);
int c_gfileindex(char **argv);
int c_gfile(char **argv);
int handlemsg(void);
void connectserver(char *server);
