/*
 * this file is a part of yabbs - yet another bulletin board system.
 * Copyright (C) 1993 Alex Wetmore.  
 * email: aw2t@andrew.cmu.edu
 * address: 6 rech ave
 *          oreland pa 19075
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#define EXTERN 
#include "bbsdefs.h"

/* ---- main just runs the correct main based on the name ------------- */

void main(int argc, char **argv) {
    /*
     * setup the terminal device so that we can deal with characters
     * ourselves, instead of letting the device driver do that
     */
#if TERMIO
    /* Get terminal modes.                                              */
    ioctl(2, TCGETA, &term);

    /* Save modes and set certain variables dependent on modes.         */
    save = term;

    /* Set the modes to the way we want them.                           */
    term.c_lflag &= ~(ICANON|ECHO|ECHOE|ECHOK|ECHONL);
    term.c_oflag |=  (OPOST|ONLCR|TAB3);
    term.c_oflag &= ~(OCRNL|ONOCR|ONLRET);
    term.c_cc[VMIN] = 1;
    term.c_cc[VTIME] = 0;

    /* set the new modes                                                */
    ioctl(2, TCSETAW, &term);
#else                                   
    /* Get terminal modes.                                              */
    ioctl(2, TIOCGETP, &term);

    /* Save modes and set certain variables dependent on modes.         */
    save = term;

    /* Set the modes to the way we want them.                           */
    term.sg_flags |= CBREAK;
    term.sg_flags &= ~(ECHO|XTABS);
            
    /* set the new modes                                                */
    ioctl(2, TIOCSETN, &term);
#endif

    /* setup global variables                                           */
    pid = getpid();
    redraw = FALSE;
    line = 1;
    strcpy(t_clrscr, "");
    strcpy(t_hion, "");
    strcpy(t_hioff, "");
    strcpy(t_cleol, "");
    strcpy(t_upcur, "");
    strcpy(termname, "unknown");
    sputs_process = TRUE;
    elite = yeck = FALSE;

    yabbsmain(argc, argv);

#if TERMIO
    ioctl(2, TCSETAW, &save);
#else
    ioctl(2, TIOCSETN, &save);
#endif
}
